/* Direction implementation.  DO NOT MODIFY THIS FILE. */

#include "direction.h"
#include <stdexcept>
#include <string>
using namespace std;

directionT RotateClockwise(directionT input)
{
	switch(input)
	{
		#define DEFINE_DIRECTION(dir,value,x1,x2,x3,x4,x5) case dir: return value;
		#include "direction.def"
		#undef DEFINE_DIRECTION
		default: throw runtime_error("Unknown direction.");
	}
}

directionT RotateCounterclockwise(directionT input)
{
	switch(input)
	{
		#define DEFINE_DIRECTION(dir,x1,x2,value,x3,x4,x5) case dir: return value;
		#include "direction.def"
		#undef DEFINE_DIRECTION
		default: throw runtime_error("Unknown direction.");
	}
}

directionT OppositeDirection(directionT input)
{
	switch(input)
	{
		#define DEFINE_DIRECTION(dir,x1,opposite,x2,x3,x4,x5) case dir: return opposite;
		#include "direction.def"
		#undef DEFINE_DIRECTION
		default: throw runtime_error("Unknown direction.");
	}
}

void MovePointInDirection(int& x, int& y, directionT direction)
{
	switch(direction)
	{
		#define DEFINE_DIRECTION(dir, x1,x2,x3, dx, dy,x5) case dir: x += dx; y += dy; return;
		#include "direction.def"
		#undef DEFINE_DIRECTION
		default: throw runtime_error("Unknown direction.");
	}
}

directionT ReflectDirectionOffMirror(directionT incoming, diagonalDirectionT mirrorShape)
{
	switch(mirrorShape)
	{
	case UpRight:
		switch(incoming)
		{
		case North: return East;
		case East: return North;
		case South: return West;
		case West: return South;
		default: throw invalid_argument("Unknown direction.");
		}
		break;
	case DownRight:
		switch(incoming)
		{
		case North: return West;
		case West: return North;
		case South: return East;
		case East: return South;
		default: throw invalid_argument("Unknown direction.");
		}
		break;
	default:
		throw invalid_argument("Unknown direction.");
	}
}

directionT CharToDirection(char ch)
{
	switch(ch)
	{
	#define DEFINE_DIRECTION(dir,x1,x2,x3,x4,x5,chVal) case chVal: return dir;
	#include "direction.def"
	#undef DEFINE_DIRECTION
	default: throw invalid_argument("Invalid direction: " + string(1, ch));
	}
}

diagonalDirectionT CharToDiagonal(char ch)
{
	switch(ch)
	{
	case '/': return UpRight;
	case '\\': return DownRight;
	default: throw invalid_argument("Invalid direction: " + string(1, ch));
	}
}