/**
 * tileT implementation.  DO NOT MODIFY THIS FILE.
 */

#include "tile.h"
#include <stdexcept>
using namespace std;

tileT GetEmptyTilePicture()
{
	return tileEmpty;
}

tileT GetWallTilePicture()
{
	return tileWall;
}

tileT GetLaserPicture(directionT dir)
{
	switch(dir)
	{
		case North: return tileLaserNorth;
		case South: return tileLaserSouth;
		case East: return tileLaserEast;
		case West: return tileLaserWest;
		default: throw runtime_error("Unknown direction.");
	}
}

tileT GetTMirrorPicture(directionT dir)
{
	switch(dir)
	{
		case North: return tileTMirrorNorth;
		case South: return tileTMirrorSouth;
		case East: return tileTMirrorEast;
		case West: return tileTMirrorWest;
		default: throw runtime_error("Unknown direction.");
	}
}

tileT GetSensorPicture(directionT dir, bool isOn)
{
	if(isOn)
	{
		switch(dir)
		{
			case North: return tileOnSensorNorth;
			case South: return tileOnSensorSouth;
			case East: return tileOnSensorEast;
			case West: return tileOnSensorWest;
			default: throw runtime_error("Unknown direction.");
		}
	}
	else
	{
		switch(dir)
		{
			case North: return tileOffSensorNorth;
			case South: return tileOffSensorSouth;
			case East: return tileOffSensorEast;
			case West: return tileOffSensorWest;
			default: throw runtime_error("Unknown direction.");
		}
	}
}

tileT GetMirrorPicture(diagonalDirectionT dir)
{
	switch(dir)
	{
	case UpRight: return tileMirrorUpRight;
	case DownRight: return tileMirrorDownRight;
	default: throw runtime_error("Unknown direction.");
	}
}

tileT GetBeamSplitterPicture(diagonalDirectionT dir)
{
	switch(dir)
	{
	case UpRight: return tileBeamSplitterUpRight;
	case DownRight: return tileBeamSplitterDownRight;
	default: throw runtime_error("Unknown direction.");
	}
}